Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 502)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 503)
@@ -230,740 +175,197 @@
 
 
-static int PJ_THREAD_FUNC pjsua_poll(void *arg)
-{
-    pj_status_t last_err = 0;
-
-    PJ_UNUSED_ARG(arg);
-
-    do {
-	pj_time_val timeout = { 0, 10 };
-	pj_status_t status;
-	
-	status = pjsip_endpt_handle_events (pjsua.endpt, &timeout);
-	if (status != PJ_SUCCESS && status != last_err) {
-	    last_err = status;
-	    pjsua_perror(THIS_FILE, "handle_events() returned error", status);
-	}
-    } while (!pjsua.quit_flag);
-
-    return 0;
-}
-
-/**
- * Poll pjsua.
- */
-PJ_DECL(int) pjsua_handle_events(unsigned msec_timeout)
-{
-    unsigned count = 0;
-    pj_time_val tv;
+/*****************************************************************************
+ * Logging.
+ */
+
+/* Log callback */
+static void log_writer(int level, const char *buffer, int len)
+{
+    /* Write to stdout, file, and application callback. */
+
+    if (level <= (int)pjsua_var.log_cfg.console_level)
+	pj_log_write(level, buffer, len);
+
+    if (pjsua_var.log_file) {
+	pj_ssize_t size = len;
+	pj_file_write(pjsua_var.log_file, buffer, &size);
+    }
+
+    if (pjsua_var.log_cfg.cb)
+	(*pjsua_var.log_cfg.cb)(level, buffer, len);
+}
+
+
+/*
+ * Application can call this function at any time (after pjsua_create(), of
+ * course) to change logging settings.
+ */
+PJ_DEF(pj_status_t) pjsua_reconfigure_logging(const pjsua_logging_config *cfg)
+{
     pj_status_t status;
 
-    tv.sec = 0;
-    tv.msec = msec_timeout;
-    pj_time_val_normalize(&tv);
-
-    status = pjsip_endpt_handle_events2(pjsua.endpt, &tv, &count);
-    if (status != PJ_SUCCESS)
-	return -status;
-
-    return count;
-}
-
-
-#define pjsua_has_stun()    (pjsua.config.stun_port1 && \
-			     pjsua.config.stun_port2)
-
-
-/*
- * Create and initialize SIP socket (and possibly resolve public
- * address via STUN, depending on config).
- */
-static pj_status_t create_sip_udp_sock(int port,
-				       pj_sock_t *p_sock,
-				       pj_sockaddr_in *p_pub_addr)
-{
-    pj_sock_t sock;
-    pj_status_t status;
-
-    status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "socket() error", status);
-	return status;
-    }
-
-    status = pj_sock_bind_in(sock, 0, (pj_uint16_t)port);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "bind() error", status);
-	pj_sock_close(sock);
-	return status;
-    }
-
-    if (pjsua_has_stun()) {
-	status = pj_stun_get_mapped_addr(&pjsua.cp.factory, 1, &sock,
-				         &pjsua.config.stun_srv1, 
-					 pjsua.config.stun_port1,
-					 &pjsua.config.stun_srv2, 
-					 pjsua.config.stun_port2,
-				         p_pub_addr);
+    /* Save config. */
+    pjsua_logging_config_dup(pjsua_var.pool, &pjsua_var.log_cfg, cfg);
+
+    /* Redirect log function to ours */
+    pj_log_set_log_func( &log_writer );
+
+    /* Close existing file, if any */
+    if (pjsua_var.log_file) {
+	pj_file_close(pjsua_var.log_file);
+	pjsua_var.log_file = NULL;
+    }
+
+    /* If output log file is desired, create the file: */
+    if (pjsua_var.log_cfg.log_filename.slen) {
+
+	status = pj_file_open(pjsua_var.pool, 
+			      pjsua_var.log_cfg.log_filename.ptr,
+			      PJ_O_WRONLY, 
+			      &pjsua_var.log_file);
+
 	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "STUN resolve error", status);
-	    pj_sock_close(sock);
+	    pjsua_perror(THIS_FILE, "Error creating log file", status);
 	    return status;
 	}
-
-    } else {
-
-	const pj_str_t *hostname = pj_gethostname();
-	struct pj_hostent he;
-
-	status = pj_gethostbyname(hostname, &he);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to resolve local host", status);
-	    pj_sock_close(sock);
-	    return status;
-	}
-
-	pj_memset(p_pub_addr, 0, sizeof(pj_sockaddr_in));
-	p_pub_addr->sin_family = PJ_AF_INET;
-	p_pub_addr->sin_port = pj_htons((pj_uint16_t)port);
-	p_pub_addr->sin_addr = *(pj_in_addr*)he.h_addr;
-    }
-
-    *p_sock = sock;
+    }
+
+    /* Unregister msg logging if it's previously registered */
+    if (pjsua_msg_logger.id >= 0) {
+	pjsip_endpt_unregister_module(pjsua_var.endpt, &pjsua_msg_logger);
+	pjsua_msg_logger.id = -1;
+    }
+
+    /* Enable SIP message logging */
+    if (pjsua_var.log_cfg.msg_logging)
+	pjsip_endpt_register_module(pjsua_var.endpt, &pjsua_msg_logger);
+
+
     return PJ_SUCCESS;
 }
 
 
-/* 
- * Create RTP and RTCP socket pair, and possibly resolve their public
- * address via STUN.
- */
-static pj_status_t create_rtp_rtcp_sock(pjmedia_sock_info *skinfo)
-{
-    enum { 
-	RTP_RETRY = 100
-    };
-    int i;
-    static pj_uint16_t rtp_port;
-    pj_sockaddr_in mapped_addr[2];
-    pj_status_t status = PJ_SUCCESS;
-    pj_sock_t sock[2];
-
-    if (rtp_port == 0)
-	rtp_port = (pj_uint16_t)pjsua.config.start_rtp_port;
-
-    for (i=0; i<2; ++i)
-	sock[i] = PJ_INVALID_SOCKET;
-
-
-    /* Loop retry to bind RTP and RTCP sockets. */
-    for (i=0; i<RTP_RETRY; ++i, rtp_port += 2) {
-
-	/* Create and bind RTP socket. */
-	status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock[0]);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "socket() error", status);
-	    return status;
-	}
-
-	status = pj_sock_bind_in(sock[0], 0, rtp_port);
-	if (status != PJ_SUCCESS) {
-	    pj_sock_close(sock[0]); 
-	    sock[0] = PJ_INVALID_SOCKET;
-	    continue;
-	}
-
-	/* Create and bind RTCP socket. */
-	status = pj_sock_socket(PJ_AF_INET, PJ_SOCK_DGRAM, 0, &sock[1]);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "socket() error", status);
-	    pj_sock_close(sock[0]);
-	    return status;
-	}
-
-	status = pj_sock_bind_in(sock[1], 0, (pj_uint16_t)(rtp_port+1));
-	if (status != PJ_SUCCESS) {
-	    pj_sock_close(sock[0]); 
-	    sock[0] = PJ_INVALID_SOCKET;
-
-	    pj_sock_close(sock[1]); 
-	    sock[1] = PJ_INVALID_SOCKET;
-	    continue;
-	}
-
-	/*
-	 * If we're configured to use STUN, then find out the mapped address,
-	 * and make sure that the mapped RTCP port is adjacent with the RTP.
-	 */
-	if (pjsua_has_stun()) {
-	    status=pj_stun_get_mapped_addr(&pjsua.cp.factory, 2, sock,
-					   &pjsua.config.stun_srv1, 
-					   pjsua.config.stun_port1,
-					   &pjsua.config.stun_srv2, 
-					   pjsua.config.stun_port2,
-					   mapped_addr);
-	    if (status != PJ_SUCCESS) {
-		pjsua_perror(THIS_FILE, "STUN resolve error", status);
-		goto on_error;
-	    }
-
-	    if (pj_ntohs(mapped_addr[1].sin_port) == 
-		pj_ntohs(mapped_addr[0].sin_port)+1)
-	    {
-		/* Success! */
-		break;
-	    }
-
-	    pj_sock_close(sock[0]); 
-	    sock[0] = PJ_INVALID_SOCKET;
-
-	    pj_sock_close(sock[1]); 
-	    sock[1] = PJ_INVALID_SOCKET;
-
-	} else {
-	    const pj_str_t *hostname;
-	    pj_sockaddr_in addr;
-
-	    /* Get local IP address. */
-	    hostname = pj_gethostname();
-
-	    pj_memset( &addr, 0, sizeof(addr));
-	    addr.sin_family = PJ_AF_INET;
-	    status = pj_sockaddr_in_set_str_addr( &addr, hostname);
-	    if (status != PJ_SUCCESS) {
-		pjsua_perror(THIS_FILE, "Unresolvable local hostname", 
-			     status);
-		goto on_error;
-	    }
-
-	    for (i=0; i<2; ++i)
-		pj_memcpy(&mapped_addr[i], &addr, sizeof(addr));
-
-	    mapped_addr[0].sin_port=pj_htons((pj_uint16_t)rtp_port);
-	    mapped_addr[1].sin_port=pj_htons((pj_uint16_t)(rtp_port+1));
-	    break;
-	}
-    }
-
-    if (sock[0] == PJ_INVALID_SOCKET) {
-	PJ_LOG(1,(THIS_FILE, 
-		  "Unable to find appropriate RTP/RTCP ports combination"));
-	goto on_error;
-    }
-
-
-    skinfo->rtp_sock = sock[0];
-    pj_memcpy(&skinfo->rtp_addr_name, 
-	      &mapped_addr[0], sizeof(pj_sockaddr_in));
-
-    skinfo->rtcp_sock = sock[1];
-    pj_memcpy(&skinfo->rtcp_addr_name, 
-	      &mapped_addr[1], sizeof(pj_sockaddr_in));
-
-    PJ_LOG(4,(THIS_FILE, "RTP socket reachable at %s:%d",
-	      pj_inet_ntoa(skinfo->rtp_addr_name.sin_addr), 
-	      pj_ntohs(skinfo->rtp_addr_name.sin_port)));
-    PJ_LOG(4,(THIS_FILE, "RTCP socket reachable at %s:%d",
-	      pj_inet_ntoa(skinfo->rtcp_addr_name.sin_addr), 
-	      pj_ntohs(skinfo->rtcp_addr_name.sin_port)));
-
-    rtp_port += 2;
+/*****************************************************************************
+ * PJSUA Base API.
+ */
+
+/* Worker thread function. */
+static int worker_thread(void *arg)
+{
+    enum { TIMEOUT = 10 };
+
+    PJ_UNUSED_ARG(arg);
+
+    while (!pjsua_var.thread_quit_flag) {
+	int count;
+
+	count = pjsua_handle_events(TIMEOUT);
+	if (count < 0)
+	    pj_thread_sleep(TIMEOUT);
+    }
+
+    return 0;
+}
+
+
+/*
+ * Instantiate pjsua application.
+ */
+PJ_DEF(pj_status_t) pjsua_create(void)
+{
+    pj_status_t status;
+
+    /* Init pjsua data */
+    init_data();
+
+    /* Set default logging settings */
+    pjsua_logging_config_default(&pjsua_var.log_cfg);
+
+    /* Init PJLIB: */
+    status = pj_init();
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
+    /* Init PJLIB-UTIL: */
+    status = pjlib_util_init();
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
+    /* Init caching pool. */
+    pj_caching_pool_init(&pjsua_var.cp, &pj_pool_factory_default_policy, 0);
+
+    /* Create memory pool for application. */
+    pjsua_var.pool = pjsua_pool_create("pjsua", 4000, 4000);
+    
+    PJ_ASSERT_RETURN(pjsua_var.pool, PJ_ENOMEM);
+
+    /* Create mutex */
+    status = pj_mutex_create_recursive(pjsua_var.pool, "pjsua", 
+				       &pjsua_var.mutex);
+    if (status != PJ_SUCCESS) {
+	pjsua_perror(THIS_FILE, "Unable to create mutex", status);
+	return status;
+    }
+
+    /* Must create SIP endpoint to initialize SIP parser. The parser
+     * is needed for example when application needs to call pjsua_verify_url().
+     */
+    status = pjsip_endpt_create(&pjsua_var.cp.factory, 
+				pj_gethostname()->ptr, 
+				&pjsua_var.endpt);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
     return PJ_SUCCESS;
-
-on_error:
-    for (i=0; i<2; ++i) {
-	if (sock[i] != PJ_INVALID_SOCKET)
-	    pj_sock_close(sock[i]);
-    }
-    return status;
-}
-
-
-
-/**
- * Create pjsua application.
- * This initializes pjlib/pjlib-util, and creates memory pool factory to
- * be used by application.
- */
-PJ_DEF(pj_status_t) pjsua_create(void)
-{
+}
+
+
+/*
+ * Initialize pjsua with the specified settings. All the settings are 
+ * optional, and the default values will be used when the config is not
+ * specified.
+ */
+PJ_DEF(pj_status_t) pjsua_init( const pjsua_config *ua_cfg,
+				const pjsua_logging_config *log_cfg,
+				const pjsua_media_config *media_cfg)
+{
+    pjsua_config	 default_cfg;
+    pjsua_media_config	 default_media_cfg;
     pj_status_t status;
 
-    /* Init PJLIB: */
-
-    status = pj_init();
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "pj_init() error", status);
-	return status;
-    }
-
-    /* Init PJLIB-UTIL: */
-
-    status = pjlib_util_init();
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "pjlib_util_init() error", status);
-	return status;
-    }
-
-    /* Init memory pool: */
-
-    /* Init caching pool. */
-    pj_caching_pool_init(&pjsua.cp, &pj_pool_factory_default_policy, 0);
-
-    /* Create memory pool for application. */
-    pjsua.pool = pj_pool_create(&pjsua.cp.factory, "pjsua", 4000, 4000, NULL);
-
-    /* Must create endpoint to initialize SIP parser. */
-    /* Create global endpoint: */
-
-    status = pjsip_endpt_create(&pjsua.cp.factory, 
-				pj_gethostname()->ptr, 
-				&pjsua.endpt);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Unable to create SIP endpoint", status);
-	return status;
-    }
-
-    /* Must create media endpoint too */
-    status = pjmedia_endpt_create(&pjsua.cp.factory, 
-				  pjsua.config.media_has_ioqueue? NULL :
-				       pjsip_endpt_get_ioqueue(pjsua.endpt), 
-				  pjsua.config.media_thread_cnt,
-				  &pjsua.med_endpt);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, 
-		     "Media stack initialization has returned error", 
-		     status);
-	return status;
-    }
-
-
-    return PJ_SUCCESS;
-}
-
-
-
-/*
- * Init media.
- */
-static pj_status_t init_media(void)
-{
-    int i;
-    unsigned options;
-    pj_str_t codec_id;
-    pj_status_t status;
-
-    /* Register all codecs */
-#if PJMEDIA_HAS_SPEEX_CODEC
-    /* Register speex. */
-    status = pjmedia_codec_speex_init(pjsua.med_endpt, 
-				      PJMEDIA_SPEEX_NO_UWB,
-				      pjsua.config.quality, 
-				      pjsua.config.complexity );
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error initializing Speex codec",
-		     status);
-	return status;
-    }
-
-    /* Set "speex/16000/1" to have highest priority */
-    codec_id = pj_str("speex/16000/1");
-    pjmedia_codec_mgr_set_codec_priority( 
-	pjmedia_endpt_get_codec_mgr(pjsua.med_endpt),
-	&codec_id, 
-	PJMEDIA_CODEC_PRIO_HIGHEST);
-
-#endif /* PJMEDIA_HAS_SPEEX_CODEC */
-
-#if PJMEDIA_HAS_GSM_CODEC
-    /* Register GSM */
-    status = pjmedia_codec_gsm_init(pjsua.med_endpt);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error initializing GSM codec",
-		     status);
-	return status;
-    }
-#endif /* PJMEDIA_HAS_GSM_CODEC */
-
-#if PJMEDIA_HAS_G711_CODEC
-    /* Register PCMA and PCMU */
-    status = pjmedia_codec_g711_init(pjsua.med_endpt);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error initializing G711 codec",
-		     status);
-	return status;
-    }
-#endif	/* PJMEDIA_HAS_G711_CODEC */
-
-#if PJMEDIA_HAS_L16_CODEC
-    /* Register L16 family codecs, but disable all */
-    status = pjmedia_codec_l16_init(pjsua.med_endpt, 0);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Error initializing L16 codecs",
-		     status);
-	return status;
-    }
-
-    /* Disable ALL L16 codecs */
-    codec_id = pj_str("L16");
-    pjmedia_codec_mgr_set_codec_priority( 
-	pjmedia_endpt_get_codec_mgr(pjsua.med_endpt),
-	&codec_id, 
-	PJMEDIA_CODEC_PRIO_DISABLED);
-
-#endif	/* PJMEDIA_HAS_L16_CODEC */
-
-
-    /* Enable those codecs that user put with "--add-codec", and move
-     * the priority to top
-     */
-    for (i=0; i<(int)pjsua.config.codec_cnt; ++i) {
-	pjmedia_codec_mgr_set_codec_priority( 
-	    pjmedia_endpt_get_codec_mgr(pjsua.med_endpt),
-	    &pjsua.config.codec_arg[i], 
-	    PJMEDIA_CODEC_PRIO_HIGHEST);
-    }
-
-
-    /* Init options for conference bridge. */
-    options = PJMEDIA_CONF_NO_DEVICE;
-
-    /* Calculate maximum number of ports, if it's not specified */
-    if (pjsua.config.conf_ports == 0) {
-	pjsua.config.conf_ports = 3 * pjsua.config.max_calls;
-    }
-
-    /* Init conference bridge. */
-    pjsua.clock_rate = pjsua.config.clock_rate ? pjsua.config.clock_rate : 16000;
-    pjsua.samples_per_frame = pjsua.clock_rate * 10 / 1000;
-    status = pjmedia_conf_create(pjsua.pool, 
-				 pjsua.config.conf_ports, 
-				 pjsua.clock_rate, 
-				 1, /* mono */
-				 pjsua.samples_per_frame, 
-				 16, 
-				 options,
-				 &pjsua.mconf);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, 
-		     "Media stack initialization has returned error", 
-		     status);
-	return status;
-    }
-
-    if (pjsua.config.null_audio == PJ_FALSE) {
-	pjmedia_port *conf_port;
-
-	/* Create sound device port */
-	status = pjmedia_snd_port_create(pjsua.pool, 
-					 pjsua.config.snd_capture_id,
-					 pjsua.config.snd_player_id, 
-					 pjsua.clock_rate, 1 /* mono */,
-					 pjsua.samples_per_frame, 16,
-					 0, &pjsua.snd_port);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to create sound device", status);
-	    return status;
-	}
-
-	/* Get the port interface of the conference bridge */
-	conf_port = pjmedia_conf_get_master_port(pjsua.mconf);
-
-	/* Connect conference port interface to sound port */
-	pjmedia_snd_port_connect( pjsua.snd_port, conf_port);
-
-    } else {
-	pjmedia_port *null_port, *conf_port;
-
-	/* Create NULL port */
-	status = pjmedia_null_port_create(pjsua.pool, pjsua.clock_rate,
-					  1, pjsua.samples_per_frame, 16,
-					  &null_port);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to create NULL port", status);
-	    return status;
-	}
-
-	/* Get the port interface of the conference bridge */
-	conf_port = pjmedia_conf_get_master_port(pjsua.mconf);
-
-	/* Create master port to control conference bridge's clock */
-	status = pjmedia_master_port_create(pjsua.pool, null_port, conf_port,
-					    0, &pjsua.master_port);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to create master port", status);
-	    return status;
-	}
-    }
-
-    /* Create WAV file player if required: */
-
-    if (pjsua.config.wav_file.slen) {
-
-	status = pjsua_player_create(&pjsua.config.wav_file, NULL);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to create file player", 
-			 status);
-	    return status;
-	}
-    }
-
-
-    return PJ_SUCCESS;
-}
-
-
-/*
- * Copy account configuration.
- */
-static void copy_acc_config(pj_pool_t *pool,
-			    pjsua_acc_config *dst_acc,
-			    const pjsua_acc_config *src_acc)
-{
-    unsigned j;
-
-    pj_memcpy(dst_acc, src_acc, sizeof(pjsua_acc_config));
-
-    pj_strdup_with_null(pool, &dst_acc->id, &src_acc->id);
-    pj_strdup_with_null(pool, &dst_acc->reg_uri, &src_acc->reg_uri);
-    pj_strdup_with_null(pool, &dst_acc->contact, &src_acc->contact);
-    pj_strdup_with_null(pool, &dst_acc->proxy, &src_acc->proxy);
-
-    for (j=0; j<src_acc->cred_count; ++j) {
-	pj_strdup_with_null(pool, &dst_acc->cred_info[j].realm, 
-			    &src_acc->cred_info[j].realm);
-	pj_strdup_with_null(pool, &dst_acc->cred_info[j].scheme, 
-			    &src_acc->cred_info[j].scheme);
-	pj_strdup_with_null(pool, &dst_acc->cred_info[j].username, 
-			    &src_acc->cred_info[j].username);
-	pj_strdup_with_null(pool, &dst_acc->cred_info[j].data, 
-			    &src_acc->cred_info[j].data);
-    }
-}
-
-
-/*
- * Copy configuration.
- */
-void pjsua_copy_config( pj_pool_t *pool, pjsua_config *dst, 
-			const pjsua_config *src)
-{
-    unsigned i;
-
-    /* Plain memcpy */
-    pj_memcpy(dst, src, sizeof(pjsua_config));
-
-    /* Duplicate strings */
-    pj_strdup_with_null(pool, &dst->sip_host, &src->sip_host);
-    pj_strdup_with_null(pool, &dst->stun_srv1, &src->stun_srv1);
-    pj_strdup_with_null(pool, &dst->stun_srv2, &src->stun_srv2);
-    pj_strdup_with_null(pool, &dst->wav_file, &src->wav_file);
-    
-    for (i=0; i<src->codec_cnt; ++i) {
-	pj_strdup_with_null(pool, &dst->codec_arg[i], &src->codec_arg[i]);
-    }
-
-    pj_strdup_with_null(pool, &dst->outbound_proxy, &src->outbound_proxy);
-    //pj_strdup_with_null(pool, &dst->uri_to_call, &src->uri_to_call);
-
-    for (i=0; i<src->acc_cnt; ++i) {
-	pjsua_acc_config *dst_acc = &dst->acc_config[i];
-	const pjsua_acc_config *src_acc = &src->acc_config[i];
-	copy_acc_config(pool, dst_acc, src_acc);
-    }
-
-    pj_strdup_with_null(pool, &dst->log_filename, &src->log_filename);
-
-    for (i=0; i<src->buddy_cnt; ++i) {
-	pj_strdup_with_null(pool, &dst->buddy_uri[i], &src->buddy_uri[i]);
-    }
-}
-
-
-/*****************************************************************************
- * Console application custom logging:
- */
-
-
-static void log_writer(int level, const char *buffer, int len)
-{
-    /* Write to both stdout and file. */
-
-    if (level <= (int)pjsua.config.app_log_level)
-	pj_log_write(level, buffer, len);
-
-    if (pjsua.log_file) {
-	fwrite(buffer, len, 1, pjsua.log_file);
-	fflush(pjsua.log_file);
-    }
-}
-
-
-static pj_status_t logging_init()
-{
-    /* Redirect log function to ours */
-
-    pj_log_set_log_func( &log_writer );
-
-    /* If output log file is desired, create the file: */
-
-    if (pjsua.config.log_filename.slen) {
-	pjsua.log_file = fopen(pjsua.config.log_filename.ptr, "wt");
-	if (pjsua.log_file == NULL) {
-	    PJ_LOG(1,(THIS_FILE, "Unable to open log file %s", 
-		      pjsua.config.log_filename.ptr));   
-	    return -1;
-	}
-    }
-
-    /* Enable SIP message logging */
-    if (pjsua.config.msg_logging)
-	pjsip_endpt_register_module(pjsua.endpt, &pjsua_msg_logger);
-
-    return PJ_SUCCESS;
-}
-
-
-static void logging_shutdown(void)
-{
-    /* Close logging file, if any: */
-
-    if (pjsua.log_file) {
-	fclose(pjsua.log_file);
-	pjsua.log_file = NULL;
-    }
-}
-
-
-/*
- * Initialize pjsua application.
- * This will initialize all libraries, create endpoint instance, and register
- * pjsip modules.
- */
-PJ_DECL(pj_status_t) pjsua_init(const pjsua_config *cfg,
-				const pjsua_callback *cb)
-{
-    char errmsg[80];
-    unsigned i;
-    pj_status_t status;
-
-
-    /* Init accounts: */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.acc); ++i) {
-	pjsua.acc[i].index = i;
-	pjsua.acc[i].online_status = PJ_TRUE;
-	pj_list_init(&pjsua.acc[i].route_set);
-	pj_list_init(&pjsua.acc[i].pres_srv_list);
-    }
-
-    /* Init call array: */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.calls); ++i) {
-	pjsua.calls[i].index = i;
-	pjsua.calls[i].refresh_tm._timer_id = -1;
-	pjsua.calls[i].hangup_tm._timer_id = -1;
-	pjsua.calls[i].conf_slot = 0;
-    }
-
-    /* Init buddies array */
-    for (i=0; i<PJ_ARRAY_SIZE(pjsua.buddies); ++i) {
-	pjsua.buddies[i].index = i;
-    }
-
-    /* Copy configuration */
-    pjsua_copy_config(pjsua.pool, &pjsua.config, cfg);
-
-    /* Copy callback */
-    pj_memcpy(&pjsua.cb, cb, sizeof(pjsua_callback));
-
-    /* Test configuration */
-    if (pjsua_test_config(&pjsua.config, errmsg, sizeof(errmsg))) {
-	PJ_LOG(1,(THIS_FILE, "Error in configuration: %s", errmsg));
-	status = -1;
-	goto on_error;
-    }
-
-
-    /* Init PJLIB logging: */
-
-    pj_log_set_level(pjsua.config.log_level);
-    pj_log_set_decor(pjsua.config.log_decor);
-
-    status = logging_init();
-    if (status != PJ_SUCCESS)
-	goto on_error;
-
-
-    /* Create SIP UDP socket */
-    if (pjsua.config.udp_port) {
-
-	status = create_sip_udp_sock( pjsua.config.udp_port,
-				      &pjsua.sip_sock,
-				      &pjsua.sip_sock_name);
-	if (status != PJ_SUCCESS)
-	    goto on_error;
-    
-	pj_strdup2_with_null(pjsua.pool, &pjsua.config.sip_host,
-			     pj_inet_ntoa(pjsua.sip_sock_name.sin_addr));
-	pjsua.config.sip_port = pj_ntohs(pjsua.sip_sock_name.sin_port);
-
-    } else {
-
-	/* Check that SIP host and port is configured */
-	if (cfg->sip_host.slen == 0 || cfg->sip_port == 0) {
-	    PJ_LOG(1,(THIS_FILE, 
-		      "Error: sip_host and sip_port must be specified"));
-	    status = PJ_EINVAL;
-	    goto on_error;
-	}
-
-	pjsua.sip_sock = PJ_INVALID_SOCKET;
-    }
-
-
-    /* Init media endpoint */
-    status = init_media();
-    if (status != PJ_SUCCESS)
-	goto on_error;
-
-
-    /* Init RTP sockets, only when UDP transport is enabled */
-    for (i=0; pjsua.config.start_rtp_port && i<pjsua.config.max_calls; ++i) {
-	status = create_rtp_rtcp_sock(&pjsua.calls[i].skinfo);
-	if (status != PJ_SUCCESS) {
-	    unsigned j;
-	    for (j=0; j<i; ++j) {
-		if (pjsua.calls[i].med_tp)
-		    pjsua.calls[i].med_tp->op->destroy(pjsua.calls[i].med_tp);
-	    }
-	    goto on_error;
-	}
-	status = pjmedia_transport_udp_attach(pjsua.med_endpt, NULL,
-					      &pjsua.calls[i].skinfo, 0,
-					      &pjsua.calls[i].med_tp);
-    }
-
-    /* Init PJSIP : */
+
+    /* Create default configurations when the config is not supplied */
+
+    if (ua_cfg == NULL) {
+	pjsua_config_default(&default_cfg);
+	ua_cfg = &default_cfg;
+    }
+
+    if (media_cfg == NULL) {
+	pjsua_media_config_default(&default_media_cfg);
+	media_cfg = &default_media_cfg;
+    }
+
+    /* Initialize logging first so that info/errors can be captured */
+    if (log_cfg) {
+	status = pjsua_reconfigure_logging(log_cfg);
+	PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+    }
+
+    /* Init SIP UA: */
 
     /* Initialize transaction layer: */
-
-    status = pjsip_tsx_layer_init_module(pjsua.endpt);
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Transaction layer initialization error", 
-		     status);
-	goto on_error;
-    }
+    status = pjsip_tsx_layer_init_module(pjsua_var.endpt);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
 
     /* Initialize UA layer module: */
-
-    status = pjsip_ua_init_module( pjsua.endpt, NULL );
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "UA layer initialization error", status);
-	goto on_error;
-    }
-
-    /* Initialize and register pjsua's application module: */
-
+    status = pjsip_ua_init_module( pjsua_var.endpt, NULL );
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
+    /* Initialize and register PJSUA application module. */
     {
-	pjsip_module my_mod = 
+	const pjsip_module mod_initializer = 
 	{
 	NULL, NULL,		    /* prev, next.			*/
@@ -982,45 +384,68 @@
 	};
 
-	pjsua.mod = my_mod;
-
-	status = pjsip_endpt_register_module(pjsua.endpt, &pjsua.mod);
-	if (status != PJ_SUCCESS) {
-	    pjsua_perror(THIS_FILE, "Unable to register pjsua module", 
-			 status);
-	    goto on_error;
+	pjsua_var.mod = mod_initializer;
+
+	status = pjsip_endpt_register_module(pjsua_var.endpt, &pjsua_var.mod);
+	PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+    }
+
+    
+
+    /* Initialize PJSUA call subsystem: */
+    status = pjsua_call_subsys_init(ua_cfg);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+
+    /* Initialize PJSUA media subsystem */
+    status = pjsua_media_subsys_init(media_cfg);
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+
+    /* Init core SIMPLE module : */
+    status = pjsip_evsub_init_module(pjsua_var.endpt);
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
+    /* Init presence module: */
+    status = pjsip_pres_init_module( pjsua_var.endpt, pjsip_evsub_instance());
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+
+    /* Init xfer/REFER module */
+    status = pjsip_xfer_init_module( pjsua_var.endpt );
+    PJ_ASSERT_RETURN(status == PJ_SUCCESS, status);
+
+    /* Init pjsua presence handler: */
+    status = pjsua_pres_init();
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /* Init out-of-dialog MESSAGE request handler. */
+    status = pjsua_im_init();
+    if (status != PJ_SUCCESS)
+	goto on_error;
+
+    /* Start worker thread if needed. */
+    if (pjsua_var.ua_cfg.thread_cnt) {
+	unsigned i;
+
+	if (pjsua_var.ua_cfg.thread_cnt > PJ_ARRAY_SIZE(pjsua_var.thread))
+	    pjsua_var.ua_cfg.thread_cnt = PJ_ARRAY_SIZE(pjsua_var.thread);
+
+	for (i=0; i<pjsua_var.ua_cfg.thread_cnt; ++i) {
+	    status = pj_thread_create(pjsua_var.pool, "pjsua", &worker_thread,
+				      NULL, 0, 0, &pjsua_var.thread[i]);
+	    if (status != PJ_SUCCESS)
+		goto on_error;
 	}
     }
 
-    /* Initialize invite session module: */
-
-    status = pjsua_call_init();
-    if (status != PJ_SUCCESS) {
-	pjsua_perror(THIS_FILE, "Invite usage initialization error", 
-		     status);
-	goto on_error;
-    }
-
-    /* Init core SIMPLE module : */
-
-    pjsip_evsub_init_module(pjsua.endpt);
-
-    /* Init presence module: */
-
-    pjsip_pres_init_module( pjsua.endpt, pjsip_evsub_instance());
-
-    /* Init xfer/REFER module */
-
-    pjsip_xfer_init_module( pjsua.endpt );
-
-    /* Init pjsua presence handler: */
-
-    pjsua_pres_init();
-
-    /* Init out-of-dialog MESSAGE request handler. */
-
-    pjsua_im_init();
-
-
-    /* Done. */
+    /* Done! */
+
+    PJ_LOG(3,(THIS_FILE, "pjsua version %s for %s initialized", 
+			 PJ_VERSION, PJ_OS_NAME));
+
     return PJ_SUCCESS;
 
